<!DOCTYPE html>
<html lang="en">
<meta charset="utf-8">
<meta http-equiv="X-UA-Compatible" content="IE=edge">
<meta name="viewport" content="width=device-width, initial-scale=1">

<head>
	<title>Sensor Scaling</title>

	<link rel='stylesheet' type="text/css" href='../css/meti_merged.css'>

	<script src='../js/meti_merged.js'></script>
	<script src='../js/meti_utils.js'></script>

	<style>
		html {
			visibility: hidden;
		}
	</style>

</head>

<body>
	<div w3-include-html="meti_bst.html"></div>

	<div class="container">
		<div class="row">
			<main role="main" class="col-sm-12 col-md-8 col-lg-6 pt-2">
				<h5 class="p-1">4-20mA Scaling Factors</h5>
				<form id="formID">
					<div class="border border-primary p-2">
						<div class="sensor_settings">
							<!-- Zero Scalling -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_zero">Zero (4 mA)</label>
								<input type="text" id="sel_zero" name="sel_zero"
									class="col-6 form-control form-control-sm"
									data-validation-engine="validate[required] custom[integer], min[-9999], max[9999]">
							</div>

							<!-- Span Scalling -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_span">Span (20 mA)</label>
								<input type="text" id="sel_span" name="sel_span"
									class="col-6 form-control form-control-sm"
									data-validation-engine="validate[required] custom[integer], min[-9999], max[9999]">
							</div>

							<!-- No. of Decimals -->
							<!-- QOS -->
							<div class="form-group p-0 m-1 row">
								<label class="col-6" for="sel_decimals">Decimal places</label>
								<select class="col-6 form-control form-control-sm" id="sel_decimals" name="sel_decimals" size="1">
								</select>
							</div>
						</div>

						<div class="col-sm-12 form-group row mt-4 mb-1">
							<button type="button" id="button_cancel"
								class="btn btn-warning col ml-4 mr-4">Cancel</button>
							<button type="button" id="button_save" class="btn btn-success col ml-4 mr-4">Save</button>
						</div>
					</div>
				</form>
			</main>
		</div>
</body>

<footer class="page-footer font-small blue pt-4">
	<div w3-include-html="footer.html"></div>
</footer>

</html>

<script>
	w3IncludeHTML();

	$(document).ready(function () {
		// display all items
		document.getElementsByTagName("html")[0].style.visibility = "visible";

		setupSelects();

		function setupSelects() {
			//keep alive
			dataArray = [0, 1, 2, 3]
			for (idx = 0; idx < dataArray.length; idx++) {
				var opt = $('<option></option>')
					.val(dataArray[idx])
					.addClass('dropdown-item')
					.addClass('dd-item')
					.text(dataArray[idx]);

				$("#sel_decimals").append(opt);
			}
		}

		$("#button_save").on("click", function () {
			if ($("#formID").validationEngine('validate')) {
				var r = confirm("Save Sensor Scaling configuration?");
				if (r == true) {
					save_config();
				}
			}
		});

		$("#button_cancel").on("click", function () {
			document.location.href = "index.html";
		});

		function load_form_data() {
			$("#packet_version").val(g_sensorScaling_db.pkt_ver);
			$("#sel_zero").val(g_sensorScaling_db.zero);
			$("#sel_span").val(g_sensorScaling_db.span);
			$("#sel_decimals").val(g_sensorScaling_db.decimals);
		}

		function save_config() {
			var debug = 0;

			g_sensorScaling_db.zero = $("#sel_zero").val();
			g_sensorScaling_db.span = $("#sel_span").val();
			g_sensorScaling_db.decimals = $("#sel_decimals").val();

			var url = "/updateSensorScaling";
			var type = 'POST';
			var data = {
				sensorScaling: JSON.stringify(g_sensorScaling_db)
			};

			$.ajax({
				url: url,
				type: type,
				data: data,
				success: function (response) {
					if (debug == 1) {
						console.log(response);
					}
					else {
						// console.log(js_response);
						var result = response.result;

						if (result == 1) {
							alert(response.message);
						}
						else if (result == 0) {
							alert(response.message);
						}
					}
				},
				error: function (jqXHR, exception, response) {
					alert('POST Error!');
				}
			});
		}

		function noSensorData(response) {
			console.log("POST Error...")
		}

		function updateDevicesParams(response) {
			$("#sel_clientId").val(response.dev_id);
		}
		//********* Call all start up functions after this line *******//

		setTimeout(function () {
			getDeviceParams(updateDevicesParams, noSensorData);
		}, 500);

		setTimeout(function () {
			readSensorScalingFromFS(load_form_data);
		}, 750);

		$("#formID").validationEngine();
	});

</script>